;********************************************************
; 	 
;	 .. () 2003 .
;********************************************************

;      6000 / - 200 .
; ..   5. 
; 1   .

; +++++++++++++++++++++    1 +++++++++++++++++ 
; B4...B7 	- 
; B3		- 
; B2		- R/W
; B1		- RS

; +++++++++++++++++++++  MCU ++++++++++++++++++++++

; RA2		-    
; RB0		-   
; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;		LIST		P=16F628

;   <my_mac.inc>    ,  
;   


#include <my_mac.inc>
#include <p16f628.inc>

 __CONFIG _CP_OFF & _WDT_ON & _BODEN_OFF & _PWRTE_ON & _XT_OSC & _LVP_OFF


place equ	0; (1...16)      

LSB		 EQU	0

LCD_DATA         EQU     PORTB
LCD_DATA_TRIS    EQU     TRISB
LCD_CNTL         EQU     PORTB
LCD_CNTL_TRIS    EQU     TRISB

;   

#define	E	LCD_CNTL,3	;  
#define	RW	LCD_CNTL,2	;  R/W
#define	RS	LCD_CNTL,1	;  RS


	CBLOCK 20

rab1	; bcd
rab2	; bcd
rab3	; bcd
Temp	; (LCD)- busy    DDRAM
Char	; (LCD)-c     
w_temp  ;  W   
pclath_temp	; PCLATH     
status_temp	; STATUS   
temp1
temp2	;    
temp3	;    
tik2	;  2  65536 
disph,displ	;   
turbo	;      
empty	;      
mod	;       
tahh	;     
tahl	;     
tahh1,tahl1,tahh2,tahl2,tahh3,tahl3,tahh4,tahl4,tahh5,tahl5
aargb0		;  
aargb1		;  
aargb2		;  
bargb0		;  
bargb1		;  
remb0		;  
remb1		;  
LOOPCOUNT
count
cnt1,cnt2	;  
tahocount
flag
	ENDC

 org    0x00

	goto    START
 org    0x04
;*************************************************
;  
;*************************************************
interrupt
	movwf   w_temp          ;W -->    
	swapf	STATUS,w        ;STATUS -->    
	clrf	status
	movwf	status_temp
	movfw	pclath
	movwf	pclath_temp

	btfsc	intcon,intf
	call	taho
	bcf	intcon,intf
	btfsc	pir1,tmr1if
	call	no_tahom
	bcf	pir1,tmr1if
	
	btfsc	pir1,tmr2if
	call	zaslonka
	bcf	pir1,tmr2if

end_int	movfw	pclath_temp
	movwf	pclath
	swapf	status_temp,w
	movwf	status
	swapf	w_temp,f
	swapf	w_temp,w

	retfie 

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;                
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

proc7	
	call Wait_Busy	;     
	movlw	01	; 
	call	Send_Cmd
	movlw	Line1
	call	Send_cmd

	movlw	20
	call	sch_b

	btfsc	flag,0
	goto	text2
	
	movlw	'T'	;"T"
	call	sch_b
	movlw	'A'	;"A"
	call	sch_b
	movlw	'X'	;"X"
	call	sch_b
	movlw	'O'	;"O"
	call	sch_b
	movlw	'M'	;"M"
	call	sch_b
	movlw	'E'	;"E"
	call	sch_b
	movlw	'T'	;"T"
	call	sch_b
	movlw	'P'	;"P"
	call	sch_b

v3	movlw	20		;   
	call	sch_b
	movlw	20		;   
	call	sch_b
	
div23	movlw	0B	;  0B7228(750120)
	movwf	aargb0	;    
	movlw	72	; 1,  
	movwf	aargb1	;   
	movlw	28
	movwf	aargb2
	movlw	40	;   450
	subwf 	tahh,w	; 
	skpnc
	goto	taho_zero
	movfw	tahh
        movwf   bargb0
        movfw   tahl
        movwf   bargb1
	
	call	div2315	; 23/15
	movfw	aargb1
	movwf	disph
	movfw	aargb2
	movwf	displ
conv	call	bcd16	;   

	movf	rab1,w	;  
	addlw	30
	call	sch_b
	movf	rab2,w	;  
	addlw	30
	call	sch_b
	movf	rab3,w	;  
	addlw	30
	call	sch_b
	movlw	30	;  
	call	sch_b
	movlw	20
	call	sch_b
	
;   

norm	movlw	3C		; disph:displ
	subwf	displ,f		; 3H (60 .)
	skpc			;(  600 /)
	decf	disph
	movfw	disph		;  disph,
	sublw	2		; ,  disph:displ<3CH.
	skpc			;    
	goto	null
	rrf	displ,f		;  2  
	bcf	displ,7		; 
	rrf	disph,f
	btfsc	status,c
	bsf	displ,7
	bcf	disph,7
	movfw	disph		; disph  
	skpnz			;..  disph:displ>0FFH,
	goto	$+3		;   ,
	movlw	0FF		;   n>=5720 /.
	movwf	displ
	movfw	displ
	movwf	temp3

str62	call Wait_Busy	   	;    	
	movlw	Line2		;  
	call	Send_Cmd	;
	call	line		;   

	return

null	clrf	temp3
	goto	str62

taho_zero
	clrf	aargb1
	clrf	aargb2
	goto	conv

text2
	movlw	0A4	;""
	call	sch_b
	movlw	'A'	;"A"
	call	sch_b
	movlw	'C'	;"C"
	call	sch_b
	movlw	0A7	;""
	call	sch_b
	movlw	'O'	;"O"
	call	sch_b
	movlw	'H'	;"H"
	call	sch_b
	movlw	'K'	;"K"
	call	sch_b
	movlw	'A'	;"A"
	call	sch_b
	goto 	v3
;*****************************************************

taho    
	decfsz	tahocount
	return

	bcf	t1con,tmr1on	;   1
        movfw   tmr1h
	movwf	tahh5
	movfw	tmr1l
	movwf	tahl5
	movfw	tmr1h
	subwf	tahh5,w
	btfsc	status,z
	goto	contin
	movfw	tmr1h
	movwf	tahh5
	movfw	tmr1l
	movwf	tahl5
contin	
	clrf	tmr1l
	clrf	tmr1h
	movlw	4
	movwf	tahocount
	bsf	t1con,tmr1on

	rrf	tahl5,f		;   4
	bcf	tahl5,7
	bcf	status,c
	rrf	tahh5,f
	btfsc	status,c
	bsf	tahl5,7
	bcf	tahh5,7
	rrf	tahl5,f
	bcf	tahl5,7
	bcf	status,c
	rrf	tahh5,f
	btfsc	status,c
	bsf	tahl5,7

middle				;  
	clrf	tahh
	clrf	tahl
	movff	tahh2,tahh1
	movff	tahl2,tahl1
	movff	tahh3,tahh2
	movff	tahl3,tahl2
	movff	tahh4,tahh3
	movff	tahl4,tahl3
	movff	tahh5,tahh4
	movff	tahl5,tahl4
add16				; 4- 
	movfw	tahl1
	addwf	tahl,f
	btfsc	status,c
	incf	tahh,f
	movfw	tahh1
	addwf	tahh

	movfw	tahl2
	addwf	tahl,f
	btfsc	status,c
	incf	tahh,f
	movfw	tahh2
	addwf	tahh

	movfw	tahl3
	addwf	tahl,f
	btfsc	status,c
	incf	tahh,f
	movfw	tahh3
	addwf	tahh

	movfw	tahl4
	addwf	tahl,f
	btfsc	status,c
	incf	tahh,f
	movfw	tahh4
	addwf	tahh

div16
	rrf	tahl,f		;   4
	bcf	tahl,7
	bcf	status,c
	rrf	tahh,f
	btfsc	status,c
	bsf	tahl,7
	bcf	tahh,7
	rrf	tahl,f
	bcf	tahl,7
	bcf	status,c
	rrf	tahh,f
	btfsc	status,c
	bsf	tahl,7


	return
no_tahom
	movlw	40
	movwf	tahh
	return
;****************************************************
;     
;****************************************************
BCD16   bcf     STATUS,0        
	movlw   .16
	movwf   count
	clrf    rab1
	clrf    rab2
	clrf    rab3
loop16  rlf     aargb2, F
	rlf     aargb1, F
	rlf     rab3, F
	rlf     rab2, F
	rlf     rab1, F
	decfsz  count, F
	goto    adjDEC

sw	movfw	rab2		;  BCD
	andlw	0F
	movwf	rab1
	movfw	rab3
	andlw	0F0
	movwf	rab2
	swapf	rab2,f
	movfw	rab3
	andlw	0F
	movwf	rab3
	RETLW   0

adjDEC  movlw   rab3
	movwf   FSR
	call    adjBCD
	movlw   rab2
	movwf   FSR
	call    adjBCD
	movlw   rab1
	movwf   FSR
	call    adjBCD
	goto    loop16
adjBCD  movlw   3
	addwf   0,W
	movwf   temp
	btfsc   temp,3          ; test if result > 7
	movwf   0
	movlw   30
	addwf   0,W
	movwf   temp
	btfsc   temp,7          ; test if result > 7
	movwf   0               ; save as MSD
	RETLW   0

;**************************************************** 
;  
;****************************************************
delay100
	movlw	4E
	movwf	cnt1
	clrf	cnt2
	decfsz	cnt2,f
	goto	$+2
	decfsz	cnt1,f
	goto	$-3
	return
delay20 movlw	10
	movwf	cnt1
	clrf	cnt2
	decfsz	cnt2,f
	goto	$+2
	decfsz	cnt1,f
	goto	$-3
	return
delay5  movlw	4
	movwf	cnt1
	clrf	cnt2
	decfsz	cnt2,f
	goto	$+2
	decfsz	cnt1,f
	goto	$-3
	nop
	return

d500mks
	mvi	temp2,.100
dl2	nop
	nop
	decfsz	temp2,f
	goto	dl2
	return

d100mks mvi temp2,.25
dll	nop			;4 x 50 = 100 mkc
	decfsz temp2,f
	goto dll
	return

;******************************************
;   temp3 (000 - 0FFH)
;     
;******************************************
line    
	movf	temp3,w
	movwf	turbo
        bcf     mod,7		;  
        movlw   0F8
        andwf   turbo,w
        btfsc   status,z
        goto    zero
        btfsc   turbo,3 	;  
        bsf     mod,7  		;  
        movlw   0F0
        andwf   turbo,f   	;  16
        swapf   turbo,f 	;  
        movf    turbo,w
        sublw   .16
        movwf   empty   	;  
        btfsc   mod,7
        decf    empty
        movlw   Line2
        call    Send_cmd
znak    movlw   0FF		;  	
        andwf   turbo,w
        btfsc   status,z
        goto    half
        clrw
        call    sch_b
        decfsz  turbo
        goto    znak
half    btfss   mod,7		;  
        goto    probel
        movlw   1
        call    sch_b
probel  movlw   0FF		; 
        andwf   empty,f
        btfsc   status,z
        return
        movlw   20
        call    sch_b
        decfsz  empty
        goto    probel
        return
zero    movlw   .16
        movwf   empty
        goto    probel

;**************************************************************
;  4-   2-
;**************************************************************
DIV2315
	clrf	remb0
	clrf	remb1
	MOVF 	BARGB1,W
	SUBWF 	REMB1, F
	MOVF 	BARGB0,W
	BTFSS 	STATUS,C
	INCFSZ 	BARGB0,W
	SUBWF 	REMB0, F
	RLF 	AARGB0, F
	MOVLW 	7
	MOVWF 	LOOPCOUNT
LOOPU2315A RLF 	AARGB0,W
	RLF 	REMB1, F
	RLF 	REMB0, F
	MOVF 	BARGB1,W
	BTFSS 	AARGB0,LSB
	GOTO 	UADD35LA
	SUBWF 	REMB1, F
	MOVF 	BARGB0,W
	BTFSS 	STATUS,C
	INCFSZ 	BARGB0,W
	SUBWF 	REMB0, F
	GOTO 	UOK35LA
UADD35LA ADDWF 	REMB1, F
	MOVF 	BARGB0,W
	BTFSC 	STATUS,C
	INCFSZ 	BARGB0,W
	ADDWF 	REMB0, F
UOK35LA RLF 	AARGB0, F
	DECFSZ 	LOOPCOUNT, F
	GOTO 	LOOPU2315A
	RLF 	AARGB1,W
	RLF 	REMB1, F
	RLF 	REMB0, F
	MOVF 	BARGB1,W
	BTFSS 	AARGB0,LSB
	GOTO 	UADD35L8
	SUBWF 	REMB1, F
	MOVF 	BARGB0,W
	BTFSS 	STATUS,C
	INCFSZ 	BARGB0,W
	SUBWF 	REMB0, F
	GOTO 	UOK35L8
UADD35L8 ADDWF 	REMB1, F
	MOVF 	BARGB0,W
	BTFSC 	STATUS,C
	INCFSZ 	BARGB0,W
	ADDWF 	REMB0, F
UOK35L8 RLF 	AARGB1, F
	MOVLW 	7
	MOVWF 	LOOPCOUNT
LOOPU2315B RLF 	AARGB1,W
	RLF 	REMB1, F
	RLF 	REMB0, F
	MOVF 	BARGB1,W
	BTFSS 	AARGB1,LSB
	GOTO 	UADD35LB
	SUBWF 	REMB1, F
	MOVF 	BARGB0,W
	BTFSS 	STATUS,C
	INCFSZ 	BARGB0,W
	SUBWF 	REMB0, F
	GOTO 	UOK35LB
UADD35LB ADDWF 	REMB1, F
	MOVF 	BARGB0,W
	BTFSC 	STATUS,C
	INCFSZ 	BARGB0,W
	ADDWF 	REMB0, F
UOK35LB RLF 	AARGB1, F
	DECFSZ 	LOOPCOUNT, F
	GOTO 	LOOPU2315B
	RLF 	AARGB2,W
	RLF 	REMB1, F
	RLF 	REMB0, F
	MOVF 	BARGB1,W
	BTFSS 	AARGB1,LSB
	GOTO 	UADD35L16
	SUBWF 	REMB1, F
	MOVF 	BARGB0,W
	BTFSS 	STATUS,C
	INCFSZ 	BARGB0,W
	SUBWF 	REMB0, F
	GOTO 	UOK35L16
UADD35L16 ADDWF REMB1, F
	MOVF 	BARGB0,W
	BTFSC 	STATUS,C
	INCFSZ 	BARGB0,W
	ADDWF 	REMB0, F
UOK35L16 RLF 	AARGB2, F
	MOVLW 	7
	MOVWF 	LOOPCOUNT
LOOPU2315C RLF 	AARGB2,W
	RLF 	REMB1, F
	RLF 	REMB0, F
	MOVF 	BARGB1,W
	BTFSS 	AARGB2,LSB
	GOTO 	UADD35LC
	SUBWF 	REMB1, F
	MOVF 	BARGB0,W
	BTFSS 	STATUS,C
	INCFSZ 	BARGB0,W
	SUBWF 	REMB0, F
	GOTO 	UOK35LC
UADD35LC ADDWF 	REMB1, F
	MOVF 	BARGB0,W
	BTFSC 	STATUS,C
	INCFSZ 	BARGB0,W
	ADDWF 	REMB0, F
UOK35LC RLF 	AARGB2, F
	DECFSZ 	LOOPCOUNT, F
	GOTO 	LOOPU2315C
	BTFSC 	AARGB2,LSB
	GOTO 	UOK35L
	MOVF 	BARGB1,W
	ADDWF 	REMB1, F
	MOVF 	BARGB0,W
	BTFSC 	STATUS,C
	INCFSZ 	BARGB0,W
	ADDWF 	REMB0, F
UOK35L
	return
;***************************************************************
zaslonka
	btfsc	porta,2
	goto	end_zasl
	incf	tik2
	btfsc	tik2,4
	goto	$+3
	bcf	flag,0
	goto	$+2
	bsf	flag,0
	return
end_zasl
;	clrf	tik2
	clrf	flag
	
	return
;***************************************************************
;  
#include	<lcdrout.inc>
;***************************************************************
START
	clrwdt
        bcf     intcon,gie
        bcf     intcon,inte
        bcf	intcon,rbie
        bcf	intcon,t0ie
   	bsf 	STATUS,RP0	;  1
   	bsf	pcon,0		;      
        movlw   .255            ;  
        movwf   pr2             ;
	bsf	pie1,tmr1ie	;   1
	bsf	pie1,tmr2ie	;   2
	movlw 	b'10001111'	; 1:128  WDT,
	movwf 	OPTION_REG	;  CLK, RBPU - 
	clrwdt
  	movlw	b'00000100' 	;    
	movwf 	trisA
	movlw	b'00000001'	; 7-B1,B0  , 0 - 
	movwf 	trisb		;
        bcf 	STATUS,RP0  	;  0
	movlw	b'00100101'	; 1:4, 1 
	movwf	t1con
	movlw	b'01111111'	; 1:16,  1:16
	movwf	t2con		; 2 
	movlw	07
	movwf	cmcon
	call    LCD_Init        ;  
	movlw   CLR_DISP	;
	call    Send_Cmd
	movlw   b'00001100'	
	call    Send_Cmd
	movlw   b'00000110'	
	call    Send_Cmd
	movlw	4
	movwf	tahocount	
	bsf	intcon,peie	;  
        bsf	intcon,inte	;  0
        bsf     intcon,gie	; 

loop
        call    proc7
	call	delay100
	clrwdt
	call	delay100
	clrwdt
	goto 	loop

	END
